diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
index f40415e21..adf2a48bd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
@@ -5,43 +5,36 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class MobWaterAnimal extends MobPathfinder
-	implements WaterCreature
-{
+public abstract class MobWaterAnimal extends MobPathfinder
+    implements WaterCreature {
 
-    public MobWaterAnimal(World world)
-    {
+    public MobWaterAnimal(World world) {
         super(world);
-        scoreValue = 10;
+        this.scoreValue = 10;
     }
 
     @Override
-	public boolean canBreatheUnderwater()
-    {
+    public boolean canBreatheUnderwater() {
         return true;
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         super.readAdditionalSaveData(tag);
     }
 
     @Override
-	public boolean canSpawnHere()
-    {
-        return world.checkIfAABBIsClear(bb);
+    public boolean canSpawnHere() {
+        return this.world.checkIfAABBIsClear(this.bb);
     }
 
     @Override
-	public int getAmbientSoundInterval()
-    {
+    public int getAmbientSoundInterval() {
         return 120;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index 73764f68c..deabb3348 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -14,32 +14,32 @@ import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.World;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
 import java.util.*;
 
 public class MobWolf
     extends MobAnimal
-    implements IItemHolding, AgedMob
-{
-    public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
+    implements IItemHolding, AgedMob {
+    public static final Map<ArmorMaterial, IArmorItem<?>> ARMOR_MATERIALS = new HashMap<>();
+
     static {
-        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER,   (IArmorItem) Items.ARMOR_CHESTPLATE_LEATHER);
-        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem) Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        ARMOR_MATERIALS.put(ArmorMaterial.IRON,      (IArmorItem) Items.ARMOR_CHESTPLATE_IRON);
-        ARMOR_MATERIALS.put(ArmorMaterial.GOLD,      (IArmorItem) Items.ARMOR_CHESTPLATE_GOLD);
-        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND,   (IArmorItem) Items.ARMOR_CHESTPLATE_DIAMOND);
-        ARMOR_MATERIALS.put(ArmorMaterial.STEEL,     (IArmorItem) Items.ARMOR_CHESTPLATE_STEEL);
+        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_LEATHER);
+        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        ARMOR_MATERIALS.put(ArmorMaterial.IRON, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_IRON);
+        ARMOR_MATERIALS.put(ArmorMaterial.GOLD, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_GOLD);
+        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_DIAMOND);
+        ARMOR_MATERIALS.put(ArmorMaterial.STEEL, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_STEEL);
     }
 
     public static final int DATA_HELD_ITEM = 15;
     public static final int DATA_GENERIC_FLAGS = 16;
-    public static final int MASK_SITTING =  0b0000_0001;
-    public static final int MASK_ANGRY =    0b0000_0010;
-    public static final int MASK_TAMED =    0b0000_0100;
+    public static final int MASK_SITTING = 0b0000_0001;
+    public static final int MASK_ANGRY = 0b0000_0010;
+    public static final int MASK_TAMED = 0b0000_0100;
     public static final int DATA_OWNER_UUID = 17;
     public static final int DATA_ARMOR_MATERIAL = 19;
 
@@ -53,28 +53,27 @@ public class MobWolf
     private ItemStack armor = null;
     private final @NotNull MobAge age;
 
-    public MobWolf(World world)
-    {
+    public MobWolf(World world) {
         super(world);
-        looksWithInterest = false;
+        this.looksWithInterest = false;
         setTextureIdentifier("minecraft", "wolf");
         setSize(0.8F, 0.8F);
-        moveSpeed = 1.1F;
-        scoreValue = 500;
-        age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 2, 14, MobAge.YEAR_LENGTH_DAYS * 2);
+        this.moveSpeed = 1.1F;
+        this.scoreValue = 500;
+        this.age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 2, 14, MobAge.YEAR_LENGTH_DAYS * 2);
     }
 
     @Override
-	protected void defineSynchedData()
-    {
+    protected void defineSynchedData() {
         super.defineSynchedData();
-        entityData.define(DATA_HELD_ITEM, null, ItemStack.class);
-        entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
-        entityData.define(DATA_OWNER_UUID, null, UUID.class);
-        entityData.define(DATA_ARMOR_MATERIAL, "", String.class);
+        this.entityData.define(DATA_HELD_ITEM, null, ItemStack.class);
+        this.entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
+        this.entityData.define(DATA_OWNER_UUID, null, UUID.class);
+        this.entityData.define(DATA_ARMOR_MATERIAL, "", String.class);
     }
+
     @Override
-    public boolean sendDeathMessage(Entity entityKilledBy){
+    public boolean sendDeathMessage(Entity entityKilledBy) {
         return super.sendDeathMessage(entityKilledBy) || isWolfTamed();
     }
 
@@ -85,7 +84,7 @@ public class MobWolf
 
     @Override
     public void spawnInit() {
-        if(random.nextInt(25 /*Used to be 100, but I think having it that high would make it excessively rare*/) == 0){
+        if (this.random.nextInt(25 /*Used to be 100, but I think having it that high would make it excessively rare*/) == 0) {
             setHeldItem(new ItemStack(Items.RECORD_DOG, 1));
         }
     }
@@ -107,7 +106,7 @@ public class MobWolf
     public void setArmor(final ItemStack stack) {
         ArmorMaterial material = null;
         this.armor = stack;
-        if (stack != null && stack.getItem() instanceof IArmorItem && ARMOR_MATERIALS.containsValue(stack.getItem())){
+        if (stack != null && stack.getItem() instanceof IArmorItem && ARMOR_MATERIALS.containsValue(stack.getItem())) {
             material = ((IArmorItem<?>) stack.getItem()).getArmorMaterial();
         }
         if (material == null) {
@@ -118,51 +117,35 @@ public class MobWolf
     }
 
     @Override
-	protected boolean makeStepSound()
-    {
+    protected boolean makeStepSound() {
         return false;
     }
 
     @Override
-	public @NotNull String getEntityTexture()
-    {
-        if(isWolfTamed())
-        {
+    public @NotNull String getEntityTexture() {
+        if (isWolfTamed()) {
             return "/assets/minecraft/textures/entity/wolf_tame/" + getTextureReference() + ".png";
-        }
-        else if(isWolfAngry())
-        {
+        } else if (isWolfAngry()) {
             return "/assets/minecraft/textures/entity/wolf_angry/" + getTextureReference() + ".png";
-        }
-        else
-        {
+        } else {
             return super.getEntityTexture();
         }
     }
 
     @Override
-    public @NotNull String getDefaultEntityTexture()
-    {
-        if(isWolfTamed())
-        {
+    public @NotNull String getDefaultEntityTexture() {
+        if (isWolfTamed()) {
             return "/assets/minecraft/textures/entity/wolf_tame/0.png";
-        }
-        else if(isWolfAngry())
-        {
+        } else if (isWolfAngry()) {
             return "/assets/minecraft/textures/entity/wolf_angry/0.png";
-        }
-        else
-        {
+        } else {
             return super.getDefaultEntityTexture();
         }
     }
 
     @Override
-    public boolean collidesWith(Entity entity)
-    {
-        if (entity instanceof Player)
-        {
-            Player player = (Player) entity;
+    public boolean collidesWith(Entity entity) {
+        if (entity instanceof Player player) {
             return !player.uuid.equals(getWolfOwner()) || isWolfSitting();
         }
 
@@ -170,13 +153,12 @@ public class MobWolf
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
         tag.putBoolean("Angry", isWolfAngry());
         tag.putBoolean("Sitting", isWolfSitting());
 
-        if(getHeldItem() != null) {
+        if (getHeldItem() != null) {
             CompoundTag heldItemNBT = new CompoundTag();
             getHeldItem().writeToNBT(heldItemNBT);
 
@@ -184,36 +166,32 @@ public class MobWolf
         }
         if (getArmorMaterial() != null) {
             CompoundTag armorTag = new CompoundTag();
-            armor.writeToNBT(armorTag);
+            this.armor.writeToNBT(armorTag);
             tag.putCompound("Armor", armorTag);
         }
         UUIDHelper.writeToTag(tag, getWolfOwner(), "OwnerUUID");
 
-        age.writeTag(tag);
+        this.age.writeTag(tag);
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         super.readAdditionalSaveData(tag);
         setWolfAngry(tag.getBoolean("Angry"));
         setWolfSitting(tag.getBoolean("Sitting"));
 
         CompoundTag heldItemStack = tag.getCompound("HeldItem");
-        if(heldItemStack != null)
-        {
+        if (heldItemStack != null) {
             ItemStack stack = ItemStack.readItemStackFromNbt(heldItemStack);
-            if (stack != null)
-            {
+            if (stack != null) {
                 setHeldItem(stack);
             }
         }
 
-        if (tag.containsKey("Armor"))
-        {
+        if (tag.containsKey("Armor")) {
             ArmorMaterial material = null;
             String name = tag.getString("Armor");
-            if (!name.isEmpty()){
+            if (!name.isEmpty()) {
                 for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
                     if (mat.identifier.toString().equalsIgnoreCase(name)) {
                         material = mat;
@@ -235,7 +213,10 @@ public class MobWolf
             String s = tag.getString("Owner");
             if (!s.isEmpty()) {
                 UUIDHelper.runConversionAction(s,
-                    (uuid) -> {setWolfOwner(uuid); setWolfTamed(true);},
+                    (uuid) -> {
+                        setWolfOwner(uuid);
+                        setWolfTamed(true);
+                    },
                     null);
             }
         } else {
@@ -243,29 +224,23 @@ public class MobWolf
             setWolfTamed(true);
         }
 
-        age.readTag(tag);
+        this.age.readTag(tag);
     }
 
     @Override
-	protected boolean canDespawn()
-    {
+    protected boolean canDespawn() {
         return !isWolfTamed() && super.canDespawn();
     }
 
     @Override
-    public String getLivingSound()
-    {
-        if(isWolfAngry())
-        {
+    public String getLivingSound() {
+        if (isWolfAngry()) {
             return "mob.wolf.growl";
         }
-        if(random.nextInt(3) == 0)
-        {
-            if((isWolfTamed() && getHealth() < getMaxHealth()/2))
-            {
+        if (this.random.nextInt(3) == 0) {
+            if ((isWolfTamed() && getHealth() < getMaxHealth() / 2)) {
                 return "mob.wolf.whine";
-            } else
-            {
+            } else {
                 return "mob.wolf.panting";
             }
         } else {
@@ -274,53 +249,45 @@ public class MobWolf
     }
 
     public void whine() {
-        if(!world.isClientSide)
-        {
-            livingSoundTime = -getAmbientSoundInterval();
-            world.playSoundAtEntity(null, this, "mob.wolf.whine", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
+        if (!this.world.isClientSide) {
+            this.livingSoundTime = -getAmbientSoundInterval();
+            this.world.playSoundAtEntity(null, this, "mob.wolf.whine", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F + getPitchModifier());
         }
     }
 
     @Override
-	protected String getHurtSound()
-    {
+    protected String getHurtSound() {
         return "mob.wolf.hurt";
     }
 
     @Override
-	protected String getDeathSound()
-    {
+    protected String getDeathSound() {
         return "mob.wolf.death";
     }
 
     @Override
-	protected float getSoundVolume()
-    {
+    protected float getSoundVolume() {
         return 0.4F;
     }
 
     @Override
-    protected void dropDeathItems()
-    {
-        if(getHeldItem() != null && getHeldItem().stackSize > 0) {
-        	dropItem(getHeldItem(), 0.0f);
+    protected void dropDeathItems() {
+        if (getHeldItem() != null && getHeldItem().stackSize > 0) {
+            dropItem(getHeldItem(), 0.0f);
             setHeldItem(null);
         }
-        if (armor != null && armor.stackSize > 0){
-            dropItem(armor, 0);
+        if (this.armor != null && this.armor.stackSize > 0) {
+            dropItem(this.armor, 0);
             setArmor(null);
         }
         super.dropDeathItems();
     }
 
     @Override
-	protected void updateAI()
-    {
+    protected void updateAI() {
         super.updateAI();
-        if (getTarget() instanceof EntityItem)
-        {
-            if (getTarget().isInWater() || getTarget().isInLava() || getTarget().isInWall() || !getTarget().onGround || getTarget().isRemoved())
-            {
+        if (getTarget() instanceof EntityItem) {
+            if (getTarget().isInWater() || getTarget().isInLava() || getTarget().isInWall() || !getTarget().onGround || getTarget().isRemoved()) {
                 setTarget(null);
             }
         }
@@ -329,55 +296,49 @@ public class MobWolf
             setTarget(null);
         }
 
-        if(!this.hasAttacked && !hasPath() && isWolfTamed() && this.vehicle == null)
-        {
+        if (!this.hasAttacked && !hasPath() && isWolfTamed() && this.vehicle == null) {
             final Player owner = this.world.getPlayerEntityByUUID(getWolfOwner());
-            if(owner != null)
-            {
+            if (owner != null) {
                 final float ownerDistance = owner.distanceTo(this);
-                if(ownerDistance > 5F)
-                {
+                if (ownerDistance > 5F) {
                     setPathToOwnerOrTeleport(owner, ownerDistance);
                 }
-            } else
-            if(isInWater())
-            {
+            } else if (isInWater()) {
                 setWolfSitting(false);
             }
-        } else
-        if(getTarget() == null && !hasPath())
-        {
-            if(!isWolfTamed() && world.rand.nextInt(50) == 0){
+        } else if (getTarget() == null && !hasPath()) {
+            if (!isWolfTamed() && this.world.rand.nextInt(50) == 0) {
                 List<MobAnimal> validTargets = new ArrayList<>();
-                List<MobAnimal> nearbyAnimals = world.getEntitiesWithinAABB(MobAnimal.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                AABBd checkBB = new AABBd(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D);
+                MathHelper.aabbGrow(checkBB, 16D, 4D, 16D, checkBB);
+                List<MobAnimal> nearbyAnimals = this.world.getEntitiesWithinAABB(MobAnimal.class, checkBB);
                 if (!nearbyAnimals.isEmpty()) {
-                    for(int i = 0; i < nearbyAnimals.size(); i++){
+                    for (int i = 0; i < nearbyAnimals.size(); i++) {
                         MobAnimal animal = nearbyAnimals.get(i);
-                        if(animal instanceof MobSheep || animal instanceof MobDeer)
+                        if (animal instanceof MobSheep || animal instanceof MobDeer)
                             validTargets.add(animal);
                     }
                 }
                 if (!validTargets.isEmpty()) {
-                    setTarget(validTargets.get(world.rand.nextInt(validTargets.size())));
+                    setTarget(validTargets.get(this.world.rand.nextInt(validTargets.size())));
                 }
             }
         }
         if (getTarget() == null) {
             ItemStack heldItemSlot = getHeldItem();
-            if((heldItemSlot == null || heldItemSlot.itemID <= 0)) {
+            if ((heldItemSlot == null || heldItemSlot.itemID <= 0)) {
                 List<EntityItem> triedItems = new ArrayList<>();
-                List<EntityItem> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.fromPool(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                AABBd checkBB = new AABBd(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D);
+                MathHelper.aabbGrow(checkBB, 16D, 4D, 16D, checkBB);
+                List<EntityItem> nearbyItems = this.world.getEntitiesWithinAABB(EntityItem.class, checkBB);
                 if (!nearbyItems.isEmpty()) {
-                    while (triedItems.size() != nearbyItems.size())
-                    {
-                        EntityItem item = nearbyItems.get(world.rand.nextInt(nearbyItems.size()));
-                        if (triedItems.contains(item))
-                        {
+                    while (triedItems.size() != nearbyItems.size()) {
+                        EntityItem item = nearbyItems.get(this.world.rand.nextInt(nearbyItems.size()));
+                        if (triedItems.contains(item)) {
                             continue;
                         }
 
-                        if (item.isInWater() || item.isInLava() || item.isInWall() || !item.onGround || item.isRemoved())
-                        {
+                        if (item.isInWater() || item.isInLava() || item.isInWall() || !item.onGround || item.isRemoved()) {
                             triedItems.add(item);
                             continue;
                         }
@@ -390,8 +351,7 @@ public class MobWolf
         }
 
 
-        if(isInWater())
-        {
+        if (isInWater()) {
             setWolfSitting(false);
         }
     }
@@ -402,53 +362,40 @@ public class MobWolf
     }
 
     @Override
-	public void onLivingUpdate()
-    {
+    public void onLivingUpdate() {
         super.onLivingUpdate();
-        looksWithInterest = false;
-        if(hasCurrentTarget() && !hasPath() && !isWolfAngry())
-        {
+        this.looksWithInterest = false;
+        if (hasCurrentTarget() && !hasPath() && !isWolfAngry()) {
             Entity entity = getCurrentTarget();
-            if(entity instanceof Player)
-            {
-                Player entityplayer = (Player)entity;
+            if (entity instanceof Player entityplayer) {
                 ItemStack itemstack = entityplayer.inventory.getCurrentItem();
-                if(itemstack != null)
-                {
-                    if(!isWolfTamed() && itemstack.itemID == Items.BONE.id)
-                    {
-                        looksWithInterest = true;
-                    } else
-                    if(isWolfTamed() && (Item.itemsList[itemstack.itemID] instanceof ItemFood))
-                    {
-                        looksWithInterest = ((ItemFood)Item.itemsList[itemstack.itemID]).getIsWolfsFavoriteMeat();
+                if (itemstack != null) {
+                    if (!isWolfTamed() && itemstack.itemID == Items.BONE.id) {
+                        this.looksWithInterest = true;
+                    } else if (isWolfTamed() && (Item.itemsList[itemstack.itemID] instanceof ItemFood)) {
+                        this.looksWithInterest = ((ItemFood) Item.itemsList[itemstack.itemID]).getIsWolfsFavoriteMeat();
                     }
                 }
             }
         }
-        if(!isMultiplayerEntity && isWolfShaking && !field_25052_g && !hasPath() && onGround)
-        {
-            field_25052_g = true;
-            timeWolfIsShaking = 0.0F;
-            prevTimeWolfIsShaking = 0.0F;
-            world.sendTrackedEntityStatusUpdatePacket(this, (byte)8);
+        if (!this.isMultiplayerEntity && this.isWolfShaking && !this.field_25052_g && !hasPath() && this.onGround) {
+            this.field_25052_g = true;
+            this.timeWolfIsShaking = 0.0F;
+            this.prevTimeWolfIsShaking = 0.0F;
+            this.world.sendTrackedEntityStatusUpdatePacket(this, (byte) 8);
         }
 
         this.age.tick(this.world);
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         super.tick();
 
-        List<Entity> entitiesNearWolf = world.getEntitiesWithinAABBExcludingEntity(this, bb);
-        if(entitiesNearWolf != null && !entitiesNearWolf.isEmpty() && isAlive())
-        {
+        List<Entity> entitiesNearWolf = this.world.getEntitiesWithinAABBExcludingEntity(this, this.bb);
+        if (!entitiesNearWolf.isEmpty() && isAlive()) {
             for (Entity entity : entitiesNearWolf) {
-                if(entity instanceof EntityItem && (this.getHeldItem() == null || this.getHeldItem().getItem() == null)){
-                    EntityItem entityItem = (EntityItem) entity;
-
+                if (entity instanceof EntityItem entityItem && this.getHeldItem() == null) {
                     if (entityItem.item != null && entityItem.item.stackSize > 0 && entityItem.pickupDelay == 0) {
                         setHeldItem(entityItem.item.copy());
                         entityItem.item.stackSize = 0;
@@ -461,113 +408,90 @@ public class MobWolf
 
         }
 
-        interestedAngleOld = interestedAngle;
-        if(looksWithInterest)
-        {
-            interestedAngle = interestedAngle + (1.0F - interestedAngle) * 0.4F;
-        } else
-        {
-            interestedAngle = interestedAngle + (0.0F - interestedAngle) * 0.4F;
-        }
-        if(looksWithInterest)
-        {
-            numTicksToChaseTarget = 10;
-        }
-        if(isInWaterOrRain())
-        {
-            isWolfShaking = true;
-            field_25052_g = false;
-            timeWolfIsShaking = 0.0F;
-            prevTimeWolfIsShaking = 0.0F;
-        } else
-        if((isWolfShaking || field_25052_g) && field_25052_g)
-        {
-            if(timeWolfIsShaking == 0.0F)
-            {
-                world.playSoundAtEntity(null, this, "mob.wolf.shake", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+        this.interestedAngleOld = this.interestedAngle;
+        if (this.looksWithInterest) {
+            this.interestedAngle = this.interestedAngle + (1.0F - this.interestedAngle) * 0.4F;
+        } else {
+            this.interestedAngle = this.interestedAngle + (0.0F - this.interestedAngle) * 0.4F;
+        }
+        if (this.looksWithInterest) {
+            this.numTicksToChaseTarget = 10;
+        }
+        if (isInWaterOrRain()) {
+            this.isWolfShaking = true;
+            this.field_25052_g = false;
+            this.timeWolfIsShaking = 0.0F;
+            this.prevTimeWolfIsShaking = 0.0F;
+        } else if ((this.isWolfShaking || this.field_25052_g) && this.field_25052_g) {
+            if (this.timeWolfIsShaking == 0.0F) {
+                this.world.playSoundAtEntity(null, this, "mob.wolf.shake", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
             }
-            prevTimeWolfIsShaking = timeWolfIsShaking;
-            timeWolfIsShaking += 0.05F;
-            if(prevTimeWolfIsShaking >= 2.0F)
-            {
-                isWolfShaking = false;
-                field_25052_g = false;
-                prevTimeWolfIsShaking = 0.0F;
-                timeWolfIsShaking = 0.0F;
+            this.prevTimeWolfIsShaking = this.timeWolfIsShaking;
+            this.timeWolfIsShaking += 0.05F;
+            if (this.prevTimeWolfIsShaking >= 2.0F) {
+                this.isWolfShaking = false;
+                this.field_25052_g = false;
+                this.prevTimeWolfIsShaking = 0.0F;
+                this.timeWolfIsShaking = 0.0F;
             }
-            if(timeWolfIsShaking > 0.4F)
-            {
-                float f = (float) bb.minY;
-                int i = (int)(MathHelper.sin((timeWolfIsShaking - 0.4F) * MathHelper.PI) * 7F);
-                for(int j = 0; j < i; j++)
-                {
-                    double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth * 0.5F;
-                    double offZ = (random.nextFloat() * 2.0F - 1.0F) * bbWidth * 0.5F;
-                    world.spawnParticle("splash", x + offX, f + 0.8F, z + offZ, xd, yd, zd, 0);
+            if (this.timeWolfIsShaking > 0.4F) {
+                float f = (float) this.bb.minY;
+                int i = (int) (MathHelper.sin((this.timeWolfIsShaking - 0.4F) * MathHelper.PI) * 7F);
+                for (int j = 0; j < i; j++) {
+                    double offX = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth * 0.5F;
+                    double offZ = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth * 0.5F;
+                    this.world.spawnParticle("splash", this.x + offX, f + 0.8F, this.z + offZ, this.xd, this.yd, this.zd, 0);
                 }
 
             }
         }
     }
 
-    public boolean getWolfShaking()
-    {
-        return isWolfShaking;
+    public boolean getWolfShaking() {
+        return this.isWolfShaking;
     }
 
-    public float getShadingWhileShaking(final float partialTick)
-    {
+    public float getShadingWhileShaking(final float partialTick) {
         return 0.75F + MathHelper.lerp(this.prevTimeWolfIsShaking, this.timeWolfIsShaking, partialTick) / 8.0F;
     }
 
-    public float getShakeAngle(final float partialTick, final float offset)
-    {
+    public float getShakeAngle(final float partialTick, final float offset) {
         final float shakeTime = MathHelper.clamp((MathHelper.lerp(this.prevTimeWolfIsShaking, this.timeWolfIsShaking, partialTick) + offset) / 1.8F, 0, 1);
         return MathHelper.sin(shakeTime * MathHelper.PI) * MathHelper.sin(shakeTime * MathHelper.PI * 11F) * 0.15F * MathHelper.PI;
     }
 
-    public float getInterestedAngle(float f)
-    {
-        return (interestedAngleOld + (interestedAngle - interestedAngleOld) * f) * 0.15F * MathHelper.PI;
+    public float getInterestedAngle(float f) {
+        return (this.interestedAngleOld + (this.interestedAngle - this.interestedAngleOld) * f) * 0.15F * MathHelper.PI;
     }
 
     @Override
-	public float getHeadHeight()
-    {
-        return bbHeight * 0.8F;
+    public float getHeadHeight() {
+        return this.bbHeight * 0.8F;
     }
 
     @Override
-	protected int getLookingTilt()
-    {
-        if(isWolfSitting())
-        {
+    protected int getLookingTilt() {
+        if (isWolfSitting()) {
             return 40;
-        } else
-        {
+        } else {
             return super.getLookingTilt();
         }
     }
 
-    private void setPathToOwnerOrTeleport(final Entity owner, final float distance)
-    {
+    private void setPathToOwnerOrTeleport(final Entity owner, final float distance) {
         final Path path = this.world.getPathToEntity(this, owner, 16F);
-        if(path == null && distance > 12F)
-        {
+        if (path == null && distance > 12F) {
             final int targetX = MathHelper.floor(owner.x);
             final int targetY = MathHelper.floor(owner.bb.minY);
             final int targetZ = MathHelper.floor(owner.z);
             final byte searchRadius = 2;
-            for(int _x = -searchRadius; _x <= searchRadius; _x++)
-            {
-                for(int _z = -searchRadius; _z <= searchRadius; _z++)
-                {
-                    if(
+            for (int _x = -searchRadius; _x <= searchRadius; _x++) {
+                for (int _z = -searchRadius; _z <= searchRadius; _z++) {
+                    if (
                         (Math.abs(_x) > 1 || Math.abs(_z) > 1) &&  // forbid teleports within a 1 block radius of the player
                             this.world.isBlockNormalCube(targetX + _x, targetY - 1, targetZ + _z) && // Solid floor
                             !this.world.isBlockNormalCube(targetX + _x, targetY, targetZ + _z) && // Two blocks of clearance
-                            !this.world.isBlockNormalCube(targetX + _x, targetY + 1, targetZ + _z))
-                    {
+                            !this.world.isBlockNormalCube(targetX + _x, targetY + 1, targetZ + _z)) {
                         moveTo(targetX + _x + 0.5F, targetY, targetZ + _z + 0.5F, this.yRot, this.xRot);
                         this.fallDistance = 0;
                         return;
